UNIT Vis_Bachema_Grafik;

INTERFACE

USES
  WinApi.Windows, WinApi.Messages, System.SysUtils, System.Classes, Vcl.Graphics, Vcl.Controls, Vcl.Forms, Vcl.Dialogs,
  Vcl.StdCtrls, vcl.Buttons, Vcl.ExtCtrls, DB, IBX.IBCustomDataSet, IBX.IBQuery, TeEngine,
  Series, TeeProcs, Chart, DbChart, Vcl.ComCtrls, IBX.IBDatabase, Common, TeeTools,
  TeePageNumTool, GanttCh, frxClass, cxGraphics, cxLookAndFeels, cxLookAndFeelPainters, Vcl.Menus, dxSkinsCore, cxButtons,
  cxControls, cxContainer, cxEdit, cxCheckBox, cxTextEdit, cxMaskEdit, cxDropDownEdit, frxExportPDF, 
  cxCheckComboBox, cxDBCheckComboBox, cxLabel, frxExportImage, VclTee.TeeGDIPlus;

TYPE
  TComp = RECORD
    Series : TLineSeries;
    Query : TIBQuery;
  END;

TYPE
  TfrmVis_Bachema_Grafik = CLASS(TForm)
    Panel2 : TPanel;
    Chart : TDBChart;
    Label1 : TLabel;
    Label2 : TLabel;
    VonDate : TDateTimePicker;
    BisDate : TDateTimePicker;
    VonTime : TDateTimePicker;
    BisTime : TDateTimePicker;
    ibqBachemaDetail : TIBQuery;
    ibtReport : TIBTransaction;
    ChartTool1 : TCursorTool;
    ChartTool2 : TRectangleTool;
    SaveDialog : TSaveDialog;
    frxReportChart : TfrxReport;
    btn100Zoom : TcxButton;
    btnRefresh : TcxButton;
    btnExport : TcxButton;
    btnCalenar : TcxButton;
    ibqBachemaDetailSPS_NODE : TSmallintField;
    ibqBachemaDetailTYP : TSmallintField;
    ibqBachemaDetailELEMENT : TSmallintField;
    ibqBachemaDetailJOBID : TSmallintField;
    ibqBachemaDetailBEZEICHNUNG : TIBStringField;
    ibqParameter : TIBQuery;
    ccbParameter : TcxCheckComboBox;
    cxLabel1 : TcxLabel;
    cxLabel2 : TcxLabel;
    cxLabel3 : TcxLabel;
    ccbObjekt : TcxCheckComboBox;
    ibqObjekt : TIBQuery;
    ccbGrenzwerte : TcxCheckComboBox;
    ibqGrenzwerte : TIBQuery;
    ibqGetGrenzwerte : TIBQuery;
    cxLabel4 : TcxLabel;
    ibqGrafikprofil : TIBQuery;
    ccbGrafikprofil : TcxComboBox;
    btnBachemaGrafikProfile : TcxButton;
    ibqGrafikprofil_Messstelle : TIBQuery;
    ibqGrafikprofil_Parameter : TIBQuery;
    ibqGrafikprofil_Grenzwert : TIBQuery;
    PROCEDURE btn100ZoomClick(Sender : TObject);
    PROCEDURE FormClose(Sender : TObject; VAR Action : TCloseAction);
    PROCEDURE btnRefreshClick(Sender : TObject);
    PROCEDURE FormCreate(Sender : TObject);
    PROCEDURE ibqGrafikCalcFields(DataSet : TDataSet);
    PROCEDURE ChartTool1Change(Sender : TCursorTool; x, y : Integer; CONST XValue, YValue : Double; Series : TChartSeries; ValueIndex : Integer);
    PROCEDURE btnExportClick(Sender : TObject);
    PROCEDURE btnCalenarClick(Sender : TObject);
    PROCEDURE frxReportChartBeforePrint(Sender : TfrxReportComponent);
    PROCEDURE FormActivate(Sender : TObject);
    PROCEDURE ccbParameterPropertiesChange(Sender : TObject);
    PROCEDURE ccbParameterPropertiesClickCheck(Sender : TObject; ItemIndex : Integer; VAR AllowToggle : Boolean);
    PROCEDURE btnBachemaGrafikProfileClick(Sender : TObject);
    PROCEDURE ccbGrafikprofilPropertiesChange(Sender : TObject);
  PRIVATE
    { Private-Deklarationen }
    ClearProfile : Boolean;
    ChageProfile : Boolean;
    UN : STRING;
    VonDateTime,
    BisDateTime : TDateTime;
    SaveOnUserNameChanged : TNotifyEvent;
    RightAxisVisible : Boolean;
    Linien : ARRAY OF TComp;
    Grenzwerte : ARRAY OF TColorLineTool;
    MaxLinien : Integer;
    MaxGrenzwerte : Integer;
    PROCEDURE OnUserNameChanged(Sender : TObject);
    PROCEDURE ClearGrafikProfile;
  PUBLIC
    { Public-Deklarationen }
    PROCEDURE Drucken;
  END;

VAR
  frmVis_Bachema_Grafik : TfrmVis_Bachema_Grafik;

IMPLEMENTATION

USES
  TeeStore,
  StStrS,
  Main,
  SelectMonthCalendar, Edit_Bachema_Profile;

  {$R *.DFM}

  PROCEDURE TfrmVis_Bachema_Grafik.btn100ZoomClick(Sender : TObject);
  BEGIN
    Chart .UndoZoom;
  END;

  PROCEDURE TfrmVis_Bachema_Grafik.FormActivate(Sender : TObject);
  BEGIN
    IF Assigned(frmMain) THEN BEGIN
      frmMain.paWindowsTitel.Caption := Self.Caption;
    END;
  END;

  PROCEDURE TfrmVis_Bachema_Grafik.FormClose(Sender : TObject; VAR Action : TCloseAction);
  BEGIN
    Action := caFree;
    frmVis_Bachema_Grafik := NIL;
    CM.OnUserNameChanged := SaveOnUserNameChanged;
    IF ibtReport.InTransaction THEN BEGIN
      ibtReport.Commit;
    END;
  END;

  PROCEDURE TfrmVis_Bachema_Grafik.FormCreate(Sender : TObject);
  BEGIN
    frmVis_Bachema_Grafik := Self;
    //    UN := Username;
    UN := SUserAdmin;
    VonDate.Date := Now;
    BisDate.Date := Now;
    VonTime.Time := StrToTime('00'+FormatSettings.TimeSeparator+'00'+FormatSettings.TimeSeparator+'00');
    BisTime.Time := StrToTime('23'+FormatSettings.TimeSeparator+'59'+FormatSettings.TimeSeparator+'59');
    SaveOnUserNameChanged := CM.OnUserNameChanged;
    CM.OnUserNameChanged := Self.OnUserNameChanged;
    ChartTool2.Shape.Shadow.HorizSize := 3;
    ChartTool2.Shape.Shadow.VertSize := 3;

    ibqParameter.Open;
    ccbParameter.Properties.Items.Clear;
    WHILE NOT ibqParameter.Eof DO BEGIN
      ccbParameter.Properties.Items.AddCheckItem(ibqParameter.FieldByName('PARAM').AsString+': '+ibqParameter.FieldByName('METHODE').AsString, ibqParameter.FieldByName('JOBID').AsString);
      ibqParameter.Next;
    END;
    ibqParameter.Close;

    ibqObjekt.Open;
    ccbObjekt.Properties.Items.Clear;
    WHILE NOT ibqObjekt.Eof DO BEGIN
      ccbObjekt.Properties.Items.AddCheckItem(ibqObjekt.FieldByName('BEZEICHNUNG').AsString, ibqObjekt.FieldByName('NR').AsString);
      ibqObjekt.Next;
    END;
    ibqObjekt.Close;

    ibqGrenzwerte.Open;
    ccbGrenzwerte.Properties.Items.Clear;
    WHILE NOT ibqGrenzwerte.Eof DO BEGIN
      ccbGrenzwerte.Properties.Items.AddCheckItem(ibqGrenzwerte.FieldByName('BEZEICHNUNG').AsString, ibqGrenzwerte.FieldByName('GRENZWERT_NR').AsString);
      ibqGrenzwerte.Next;
    END;
    ibqGrenzwerte.Close;

    ibqGrafikprofil.ParamByName('Benutzer').AsString := UN;
    ibqGrafikprofil.Open;
    ccbGrafikprofil.Properties.Items.Clear;
    WHILE NOT ibqGrafikprofil.Eof DO BEGIN
      ccbGrafikprofil.Properties.Items.Add(ibqGrafikprofil.FieldByName('PROFILE').AsString+';'+ibqGrafikprofil.FieldByName('BEMERKUNG').AsString);
      ibqGrafikprofil.Next;
    END;
    ibqGrafikprofil.Close;

    btnBachemaGrafikProfile.Enabled := (pwAdministrator IN UserPasswordLevel) OR (pwDVS_EditValue IN UserPasswordLevel);
  END;

  PROCEDURE TfrmVis_Bachema_Grafik.frxReportChartBeforePrint(Sender : TfrxReportComponent);
  BEGIN
    IF Sender.Name = 'Picture1' THEN BEGIN
      TfrxPictureView(Sender).Picture.Assign(Chart .TeeCreateMetafile(False, Rect(0, 0, Round(Sender.Width), Round(Sender.Height))));
    END;
  END;

  PROCEDURE TfrmVis_Bachema_Grafik.OnUserNameChanged(Sender : TObject);
  BEGIN
    IF Assigned(SaveOnUserNameChanged) THEN BEGIN
      SaveOnUserNameChanged(Self);
    END;
  END;

  PROCEDURE TfrmVis_Bachema_Grafik.ChartTool1Change(Sender : TCursorTool; x, y : Integer; CONST XValue, YValue : Double; Series : TChartSeries; ValueIndex : Integer);
  BEGIN
    IF NOT RightAxisVisible THEN BEGIN
      ChartTool2.Text := 'Linke Achse:  '+Format('%1.2f', [Chart .LeftAxis.CalcPosPoint(y)])+#13+DateTimeToStr(XValue);
    END ELSE BEGIN
      ChartTool2.Text := 'Linke Achse:  '+Format('%1.2f', [Chart .LeftAxis.CalcPosPoint(y)])+#13+'Rechte Achse: '+Format('%1.2f', [Chart .RightAxis.CalcPosPoint(y)])+#13+DateTimeToStr(XValue);
    END;
  END;

  PROCEDURE TfrmVis_Bachema_Grafik.ClearGrafikProfile;
  VAR
    i : Integer;
  BEGIN
    FOR i := 0 TO MaxLinien-1 DO BEGIN
      FreeAndNIL(Linien[i]. Series);
      FreeAndNIL(Linien[i].Query);
    END;
    FOR i := 0 TO MaxGrenzwerte-1 DO BEGIN
      FreeAndNIL(Grenzwerte[i]);
    END;
    IF (MaxLinien > 0) THEN BEGIN
      SetLength(Linien, 0);
      MaxLinien := 0;
    END;
    IF (MaxGrenzwerte > 0) THEN BEGIN
      SetLength(Grenzwerte, 0);
      MaxGrenzwerte := 0;
    END;
    ChartTool1.Active := False;
    ChartTool2.Active := False;
    IF NOT ChageProfile THEN BEGIN
      ClearProfile := True;
      ccbGrafikprofil.ItemIndex := -1;
      ClearProfile := False;
    END;
  END;

  PROCEDURE TfrmVis_Bachema_Grafik.btnBachemaGrafikProfileClick(Sender : TObject);
  BEGIN
    Application.CreateForm(TdlgEdit_Bachema_Profile, dlgEdit_Bachema_Profile);
    IF Assigned(dlgEdit_Bachema_Profile) THEN BEGIN
      TRY
        dlgEdit_Bachema_Profile.ShowModal;
      FINALLY
        FreeAndNIL(dlgEdit_Bachema_Profile);
      END;
    END;
  END;

  PROCEDURE TfrmVis_Bachema_Grafik.Drucken;
  VAR
    C1, C2 : TColor;
  BEGIN
    C1 := Chart .BackWall.Gradient.EndColor;
    C2 := Chart .Gradient.EndColor;
    Chart .BackWall.Gradient.EndColor := clWhite;
    Chart .Gradient.EndColor := clWhite;

    ChartTool1.Visible := False;
    ChartTool2.Visible := False;

    frxReportChart.Variables['Copyright'] := ''''+SRptCopyRight+'''';
    frxReportChart.Variables['Titel'] := ''''+ReportTitle+'''';

    frxReportChart.PrepareReport;
    frxReportChart.ShowPreparedReport;

    Chart .BackWall.Gradient.EndColor := C1;
    Chart .Gradient.EndColor := C2;

    ChartTool1.Visible := True;
    ChartTool2.Visible := True;
  END;

  PROCEDURE TfrmVis_Bachema_Grafik.btnCalenarClick(Sender : TObject);
  BEGIN
    Application.CreateForm(TdlgSelectMonthCalendar, dlgSelectMonthCalendar);
    IF Assigned(dlgSelectMonthCalendar) THEN BEGIN
      IF (dlgSelectMonthCalendar.ShowModal = idOK) THEN BEGIN
        VonDate.Date := dlgSelectMonthCalendar.MonthCalendar.Date;
        BisDate.Date := dlgSelectMonthCalendar.MonthCalendar.EndDate;
      END;
      FreeAndNIL(dlgSelectMonthCalendar);
    END;
  END;

  PROCEDURE TfrmVis_Bachema_Grafik.btnExportClick(Sender : TObject);
  BEGIN
    SaveDialog.FileName := 'Bachemagrafik_'+FormatDateTime('yyyymmddhhnnss', Now);
    IF SaveDialog.Execute THEN BEGIN
      WITH TSeriesDataText.Create(Chart, NIL) DO BEGIN
        TRY
          TextDelimiter := ';';
          IncludeHeader := True;
          SaveToFile(SaveDialog.FileName);
        FINALLY
          Free;
        END;
      END;
    END;
  END;

  PROCEDURE TfrmVis_Bachema_Grafik.btnRefreshClick(Sender : TObject);
  VAR
    D1, D2,
    M1, M2,
    Y1, Y2 : Word;
    i, j, k : Integer;
    Sps, Typ, Element, JobID : Integer;
    Pen : TPenStyle;
    Color : TColor;
    left_Axis : Boolean;
    ST, ID : STRING;
    Field : TField;

    FUNCTION CreateSQL(Sps, Typ, Element, JobID : Integer; Von, Bis : STRING) : STRING;
    BEGIN
      Result := Format('SELECT Dtl.SPS_Node, Dtl.Typ, Dtl.Element, Dtl.JobID, Dtl.DatumZeit, Dtl.Wert, El.Bezeichnung, Dal.Masseinheit, Dal.Data_Type, Dal.Faktor'+
        ' FROM DatenLogging Dtl INNER JOIN Elemente El ON(Dtl.SPS_Node=El.SPS_Node)AND(Dtl.Typ=El.Typ)AND(Dtl.Element=El.Element)AND(El.JobID=Dtl.JobID)'+
        ' INNER JOIN DatenloggingTypen Dal ON(Dtl.SPS_Node=Dal.SPS_Node)AND(Dtl.Typ=Dal.Typ)AND(Dtl.Element=Dal.Element)AND(Dtl.JobID=Dal.JobID)'+
        ' WHERE (Dtl.SPS_Node=%d AND Dtl.Typ=%d AND Dtl.Element=%d AND Dtl.JobID=%d AND Dtl.DatumZeit>=''%s'' AND Dtl.DatumZeit<=''%s'')'+
        ' ORDER BY Dtl.DatumZeit', [Sps, Typ, Element, JobID, Von, Bis]);
    END;

  BEGIN
    Screen.Cursor := crHourGlass;
    VonDateTime := StrToDateTime(DateToStr(VonDate.Date)+' '+TimeToStr(VonTime.Time));
    BisDateTime := StrToDateTime(DateToStr(BisDate.Date)+' '+TimeToStr(BisTime.Time));
    DecodeDate(VonDate.Date, Y1, M1, D1);
    DecodeDate(BisDate.Date, Y2, M2, D2);
    IF (VonDateTime > BisDateTime) THEN BEGIN
      Screen.Cursor := crDefault;
      MessageDlg(SWrongDateTime, mtError, [mbOK], 0);
    END ELSE BEGIN
      TRY
        {
        TRY
        Chart .LeftAxis.Minimum := ibqProfileKopf.FieldByName('Skala_links_min').Value;
        Chart .LeftAxis.Maximum := ibqProfileKopf.FieldByName('Skala_links_max').Value;
        EXCEPT
        Chart .LeftAxis.Maximum := ibqProfileKopf.FieldByName('Skala_links_max').Value;
        Chart .LeftAxis.Minimum := ibqProfileKopf.FieldByName('Skala_links_min').Value;
        END;
        Chart .LeftAxis.Automatic := (Chart .LeftAxis.Minimum = 0) AND (Chart .LeftAxis.Maximum = 0);

        TRY
        Chart .RightAxis.Minimum := ibqProfileKopf.FieldByName('Skala_rechts_min').Value;
        Chart .RightAxis.Maximum := ibqProfileKopf.FieldByName('Skala_rechts_max').Value;
        EXCEPT
        Chart .RightAxis.Maximum := ibqProfileKopf.FieldByName('Skala_rechts_max').Value;
        Chart .RightAxis.Minimum := ibqProfileKopf.FieldByName('Skala_rechts_min').Value;
        END;
        Chart .RightAxis.Automatic := (Chart .RightAxis.Minimum = 0) AND (Chart .RightAxis.Maximum = 0);
        }

        ClearGrafikProfile;
        ibqBachemaDetail.SQL.Clear;
        ibqBachemaDetail.SQL.Add('');
        ibqBachemaDetail.SQL.Add('SELECT');
        ibqBachemaDetail.SQL.Add('  DATENLOGGINGTYPEN.SPS_NODE,');
        ibqBachemaDetail.SQL.Add('  DATENLOGGINGTYPEN.TYP,');
        ibqBachemaDetail.SQL.Add('  DATENLOGGINGTYPEN.ELEMENT,');
        ibqBachemaDetail.SQL.Add('  DATENLOGGINGTYPEN.JOBID,');
        ibqBachemaDetail.SQL.Add('  ELEMENTE.BEZEICHNUNG');
        ibqBachemaDetail.SQL.Add('FROM');
        ibqBachemaDetail.SQL.Add('  DATENLOGGINGTYPEN');
        ibqBachemaDetail.SQL.Add('  INNER JOIN ELEMENTE ON (DATENLOGGINGTYPEN.SPS_NODE = ELEMENTE.SPS_NODE)');
        ibqBachemaDetail.SQL.Add('  AND (DATENLOGGINGTYPEN.TYP = ELEMENTE.TYP)');
        ibqBachemaDetail.SQL.Add('  AND (DATENLOGGINGTYPEN.ELEMENT = ELEMENTE.ELEMENT)');
        ibqBachemaDetail.SQL.Add('  AND (DATENLOGGINGTYPEN.JOBID = ELEMENTE.JOBID)');
        ibqBachemaDetail.SQL.Add('WHERE');
        ibqBachemaDetail.SQL.Add('  DATENLOGGINGTYPEN.SPS_NODE = 200 AND');
        ibqBachemaDetail.SQL.Add('  DATENLOGGINGTYPEN.TYP = 20');
        j := WordCountS(ccbParameter.Text, ';');
        IF (ccbParameter.Text <> ccbParameter.Properties.EmptySelectionText) THEN BEGIN
          ibqBachemaDetail.SQL.Add('  AND (');
          FOR i := 1 TO j DO BEGIN
            IF (i = 1) THEN BEGIN
              ibqBachemaDetail.SQL.Add(Format('  (DATENLOGGINGTYPEN.JOBID = %s)', [ExtractWordS(i, ccbParameter.Text, ';')]));
            END ELSE BEGIN
              ibqBachemaDetail.SQL.Add(Format('  OR (DATENLOGGINGTYPEN.JOBID = %s)', [ExtractWordS(i, ccbParameter.Text, ';')]));
            END;
          END;
          ibqBachemaDetail.SQL.Add('  )');
        END;
        j := WordCountS(ccbObjekt.Text, ';');
        IF (ccbObjekt.Text <> ccbObjekt.Properties.EmptySelectionText) THEN BEGIN
          ibqBachemaDetail.SQL.Add('  AND (');
          FOR i := 1 TO j DO BEGIN
            IF (i = 1) THEN BEGIN
              ibqBachemaDetail.SQL.Add(Format('  (DATENLOGGINGTYPEN.ELEMENT = %s)', [ExtractWordS(i, ccbObjekt.Text, ';')]));
            END ELSE BEGIN
              ibqBachemaDetail.SQL.Add(Format('  OR (DATENLOGGINGTYPEN.ELEMENT = %s)', [ExtractWordS(i, ccbObjekt.Text, ';')]));
            END;
          END;
          ibqBachemaDetail.SQL.Add('  )');
        END;

        ibqBachemaDetail.Open;
        ibqBachemaDetail.Last;
        MaxLinien := ibqBachemaDetail.RecordCount;
        ibqBachemaDetail.First;
        SetLength(Linien, MaxLinien);

        ID := '';
        i := 1;
        WHILE (i <= MaxLinien) DO BEGIN
          Sps := ibqBachemaDetail.FieldByName('SPS_Node').Value;
          Typ := ibqBachemaDetail.FieldByName('Typ').Value;
          Element := ibqBachemaDetail.FieldByName('Element').Value;
          JobID := ibqBachemaDetail.FieldByName('JobID').Value;
          IF (Pos(ibqBachemaDetail.FieldByName('JobID').AsString, ID) = 0) THEN BEGIN
            IF (ID = '') THEN BEGIN
              ID := ibqBachemaDetail.FieldByName('JobID').AsString;
            END ELSE BEGIN
              ID := ID+';'+ibqBachemaDetail.FieldByName('JobID').AsString;
            END;
          END;

          //            Color := ibqBachemaDetail.FieldByName('LineColor').Value;
          //            Pen := TPenStyle(ibqBachemaDetail.FieldByName('LineStyle').Value);
          //            left_Axis := ((ibqBachemaDetail.FieldByName('Skala_Links').Value = 'Y') AND NOT(ibqBachemaDetail.FieldByName('Skala_rechts').Value = 'Y'));

          Linien[i-1].Query := TIBQuery.Create(Self);
          Linien[i-1].Query.Database := CM. IBDatabase;
          Linien[i-1].Query.Transaction := ibtReport;
          Linien[i-1].Query.SQL.Clear;
          Linien[i-1].Query.SQL.Add(CreateSQL(Sps, Typ, Element, JobID, DateTimeToStr(VonDateTime), DateTimeToStr(BisDateTime)));
          Linien[i-1].Query.FieldDefs.Add('SPS_NODE', ftSmallint, 0);
          Linien[i-1].Query.FieldDefs.Add('TYP', ftSmallint, 0);
          Linien[i-1].Query.FieldDefs.Add('ELEMENT', ftSmallint, 0);
          Linien[i-1].Query.FieldDefs.Add('JOBID', ftSmallint, 0);
          Linien[i-1].Query.FieldDefs.Add('DATUMZEIT', ftDateTime, 0);
          Linien[i-1].Query.FieldDefs.Add('WERT', ftFloat, 0);
          Linien[i-1].Query.FieldDefs.Add('BEZEICHNUNG', ftString, 100);
          Linien[i-1].Query.FieldDefs.Add('MASSEINHEIT', ftString, 10);
          Linien[i-1].Query.FieldDefs.Add('FAKTOR', ftFloat, 0);
          FOR j := 0 TO Linien[i-1].Query.FieldDefs.Count-1 DO BEGIN
            Field := Linien[i-1].Query.FieldDefs[j].CreateField(Linien[i-1].Query);
          END;

          Field := TFloatField.Create(Linien[i-1].Query);
          Field.FieldKind := fkCalculated;
          Field.FieldName := 'WertBerechnet';
          Field.DataSet := Linien[i-1].Query;
          Linien[i-1].Query.OnCalcFields := ibqGrafikCalcFields;

          Linien[i-1]. Series := TLineSeries.Create(Self);
          Linien[i-1]. Series .ParentChart := Chart;
          Linien[i-1]. Series .DataSource := Linien[i-1].Query;
          Linien[i-1]. Series .Pointer.Visible := True;

          Linien[i-1]. Series .XValues.DateTime := True;
          Linien[i-1]. Series .XValues.Name := 'X';
          Linien[i-1]. Series .XValues.Order := loAscending;
          Linien[i-1]. Series .XValues.ValueSource := 'DatumZeit';

          Linien[i-1]. Series .YValues.DateTime := False;
          Linien[i-1]. Series .YValues.Name := 'Y';
          Linien[i-1]. Series .YValues.Order := loNone;
          Linien[i-1]. Series .YValues.ValueSource := 'WertBerechnet';

          //          Linien[i-1]. Series .SeriesColor := Color;
          //          Linien[i-1]. Series .LinePen.Color := Color;
          //          Linien[i-1]. Series .LinePen.Style := Pen;
          Linien[i-1].Query.Open;
          Linien[i-1]. Series .Title := Linien[i-1].Query.FieldByName('Bezeichnung').AsString+' ['+Linien[i-1].Query.FieldByName('Masseinheit').AsString+']';
          Linien[i-1]. Series .HorizAxis := aBothHorizAxis;
          //          IF left_Axis THEN BEGIN
          //            Linien[i-1]. Series .VertAxis := aLeftAxis;
          //          END ELSE BEGIN
          //            Linien[i-1]. Series .VertAxis := aRightAxis;
          //            RightAxisVisible := True;
          //          END;
          Inc(i);
          ibqBachemaDetail.Next;
        END;
        ibqBachemaDetail.Close;

        ibqGetGrenzwerte.SQL.Clear;
        ibqGetGrenzwerte.SQL.Add('SELECT');
        ibqGetGrenzwerte.SQL.Add('  BACHEMA_GRENZWERT_POS.GRENZWERT_NR,');
        ibqGetGrenzwerte.SQL.Add('  BACHEMA_GRENZWERT_POS.PARAMETER_ID,');
        ibqGetGrenzwerte.SQL.Add('  BACHEMA_GRENZWERT_POS.GRENZWERT_TYP,');
        ibqGetGrenzwerte.SQL.Add('  BACHEMA_GRENZWERT_POS.GRENZWERT');
        ibqGetGrenzwerte.SQL.Add('FROM');
        ibqGetGrenzwerte.SQL.Add('  BACHEMA_TYPEN');
        ibqGetGrenzwerte.SQL.Add('  INNER JOIN BACHEMA_GRENZWERT_POS ON (BACHEMA_TYPEN.PARAMETER_ID = BACHEMA_GRENZWERT_POS.PARAMETER_ID)');

        j := WordCountS(ccbGrenzwerte.Text, ';');
        IF (ccbGrenzwerte.Text <> ccbGrenzwerte.Properties.EmptySelectionText) THEN BEGIN
          k := WordCountS(ID, ';');
          IF (k >= 0) THEN BEGIN
            ibqGetGrenzwerte.SQL.Add('WHERE');
            ibqGetGrenzwerte.SQL.Add('  (');
            FOR i := 1 TO k DO BEGIN
              IF (i = 1) THEN BEGIN
                ibqGetGrenzwerte.SQL.Add(Format('  (BACHEMA_TYPEN.JOBID = %s)', [ExtractWordS(i, ID, ';')]));
              END ELSE BEGIN
                ibqGetGrenzwerte.SQL.Add(Format('  OR (BACHEMA_TYPEN.JOBID = %s)', [ExtractWordS(i, ID, ';')]));
              END;
            END;
            ibqGetGrenzwerte.SQL.Add('  )');
          END;

          IF (k = 0) THEN BEGIN
            ibqGetGrenzwerte.SQL.Add('  WHERE (');
          END ELSE BEGIN
            ibqGetGrenzwerte.SQL.Add('  AND (');
          END;
          FOR i := 1 TO j DO BEGIN
            IF (i = 1) THEN BEGIN
              ibqGetGrenzwerte.SQL.Add(Format('  (BACHEMA_GRENZWERT_POS.GRENZWERT_NR = %s)', [ExtractWordS(i, ccbGrenzwerte.Text, ';')]));
            END ELSE BEGIN
              ibqGetGrenzwerte.SQL.Add(Format('  OR (BACHEMA_GRENZWERT_POS.GRENZWERT_NR = %s)', [ExtractWordS(i, ccbGrenzwerte.Text, ';')]));
            END;
          END;
          ibqGetGrenzwerte.SQL.Add('  )');

          ibqGetGrenzwerte.Open;
          ibqGetGrenzwerte.Last;
          MaxGrenzwerte := ibqGetGrenzwerte.RecordCount;
          ibqGetGrenzwerte.First;
          SetLength(Grenzwerte, MaxGrenzwerte);
          i := 1;
          WHILE (i <= MaxGrenzwerte) DO BEGIN
            Grenzwerte[i-1] := TColorLineTool.Create(Self);
            Grenzwerte[i-1].ParentChart := Chart;
            Grenzwerte[i-1].Axis := Chart .LeftAxis;
            Grenzwerte[i-1].Pen.Color := clRed;
            Grenzwerte[i-1].Style := clCustom;
            Grenzwerte[i-1].Value := ibqGetGrenzwerte.FieldByName('GRENZWERT').Value;
            Grenzwerte[i-1].Tag := ibqGetGrenzwerte.FieldByName('PARAMETER_ID').Value;
            Grenzwerte[i-1].Active := True;
            Inc(i);
            ibqGetGrenzwerte.Next;
          END;
          ibqGetGrenzwerte.Close;
        END;

        ChartTool1.Active := True;
        ChartTool2.Active := True;
        ChartTool2.AutoSize := True;
        Screen.Cursor := crDefault;
        //        Chart .Page := Chart .NumPages;
      EXCEPT
        Screen.Cursor := crDefault;
        RAISE;
      END;
    END;
  END;

  PROCEDURE TfrmVis_Bachema_Grafik.ccbGrafikprofilPropertiesChange(Sender : TObject);
  VAR
    SL : TStringList;
    i : Integer;
    Found : Boolean;
    ci : TcxCheckComboBoxItem;
  BEGIN
    IF NOT ClearProfile THEN BEGIN

      ChageProfile := True;
      TRY
        SL := TStringList.Create;
        SL.StrictDelimiter:=True;
        SL.Delimiter := ';';
        SL.DelimitedText := ccbGrafikprofil.Text;

        ibqGrafikprofil_Messstelle.ParamByName('Benutzer').AsString := UN;
        ibqGrafikprofil_Messstelle.ParamByName('profile').AsString := SL[0];
        ibqGrafikprofil_Messstelle.Open;
        FOR i := 0 TO ccbObjekt.Properties.Items.Count-1 DO BEGIN
          ccbObjekt.States[i] := cbsUnchecked;
        END;

        WHILE NOT ibqGrafikprofil_Messstelle.Eof DO BEGIN
          i := 0;
          Found := False;
          WHILE NOT Found AND (i < ccbObjekt.Properties.Items.Count-1) DO BEGIN
            ci := ccbObjekt.Properties.Items[i];
            Found := ci.ShortDescription = ibqGrafikprofil_Messstelle.FieldByName('ELEMENT').AsString;
            IF NOT Found THEN BEGIN
              Inc(i);
            END;
          END;
          IF Found THEN BEGIN
            ccbObjekt.States[i] := cbsChecked;
          END;
          ibqGrafikprofil_Messstelle.Next;
        END;
        ibqGrafikprofil_Messstelle.Close;


        ibqGrafikprofil_Parameter.ParamByName('Benutzer').AsString := UN;
        ibqGrafikprofil_Parameter.ParamByName('profile').AsString := SL[0];
        ibqGrafikprofil_Parameter.Open;
        FOR i := 0 TO ccbObjekt.Properties.Items.Count-1 DO BEGIN
          ccbParameter.States[i] := cbsUnchecked;
        END;

        WHILE NOT ibqGrafikprofil_Parameter.Eof DO BEGIN
          i := 0;
          Found := False;
          WHILE NOT Found AND (i < ccbParameter.Properties.Items.Count-1) DO BEGIN
            ci := ccbParameter.Properties.Items[i];
            Found := ci.ShortDescription = ibqGrafikprofil_Parameter.FieldByName('JOBID').AsString;
            IF NOT Found THEN BEGIN
              Inc(i);
            END;
          END;
          IF Found THEN BEGIN
            ccbParameter.States[i] := cbsChecked;
          END;
          ibqGrafikprofil_Parameter.Next;
        END;
        ibqGrafikprofil_Parameter.Close;

        ibqGrafikprofil_Grenzwert.ParamByName('Benutzer').AsString := UN;
        ibqGrafikprofil_Grenzwert.ParamByName('profile').AsString := SL[0];
        ibqGrafikprofil_Grenzwert.Open;
        FOR i := 0 TO ccbGrenzwerte.Properties.Items.Count-1 DO BEGIN
          ccbGrenzwerte.States[i] := cbsUnchecked;
        END;

        WHILE NOT ibqGrafikprofil_Grenzwert.Eof DO BEGIN
          i := 0;
          Found := False;
          WHILE NOT Found AND (i < ccbParameter.Properties.Items.Count-1) DO BEGIN
            ci := ccbGrenzwerte.Properties.Items[i];
            Found := ci.ShortDescription = ibqGrafikprofil_Grenzwert.FieldByName('GRENZWERT_NR').AsString;
            IF NOT Found THEN BEGIN
              Inc(i);
            END;
          END;
          IF Found THEN BEGIN
            ccbGrenzwerte.States[i] := cbsChecked;
          END;
          ibqGrafikprofil_Grenzwert.Next;
        END;
        ibqGrafikprofil_Grenzwert.Close;

      FINALLY
        FreeAndNIL(SL);
        ChageProfile := False;
      END;
    END;
  END;

  PROCEDURE TfrmVis_Bachema_Grafik.ccbParameterPropertiesChange(Sender : TObject);
  BEGIN
    ClearGrafikProfile;
  END;

  PROCEDURE TfrmVis_Bachema_Grafik.ccbParameterPropertiesClickCheck(Sender : TObject; ItemIndex : Integer; VAR AllowToggle : Boolean);
  BEGIN
    ClearGrafikProfile;
  END;

  PROCEDURE TfrmVis_Bachema_Grafik.ibqGrafikCalcFields(DataSet : TDataSet);
  BEGIN
    IF NOT DataSet.FieldByName('Wert').IsNull THEN BEGIN
      DataSet.FieldByName('WertBerechnet').AsFloat := DataSet.FieldByName('Wert').AsFloat*DataSet.FieldByName('Faktor').AsFloat;
    END;
  END;

END {$IFDEF VwDel456} {$WARNINGS OFF} {$ENDIF} .

